import React, { Component } from "react";
import { ToastContainer } from "react-toastify";
import AppRouter from "./AppRouter";
import store from "./Redux/store";
import { Provider } from "react-redux";
import "bootstrap/dist/css/bootstrap.min.css";
import "react-toastify/dist/ReactToastify.css";

class App extends Component {
  render() {
    return (
      <Provider store={store}>
        <AppRouter />
        <ToastContainer
          position="top-right"
          autoClose={2000}
          hideProgressBar={true}
          newestOnTop={true}
          closeOnClick
          rtl={true}
          pauseOnFocusLoss
          draggable
          pauseOnHover
        />
      </Provider>
    );
  }
}

export default App;
