import React, { Component } from "react";
import { Link } from "react-router-dom";

import "./index.scss";

const maxMobileSize = 550;

const fontSize = {
  mobile: {
    span: window.innerWidth > maxMobileSize ? 20 : window.innerWidth / 17,
    a: window.innerWidth > maxMobileSize ? 20 : window.innerWidth / 20,
  },
};
export default class QRModal extends Component {
  render() {
    const { tail, parent } = this.props;
    return (
      <>
        {window.innerWidth < 1000 ? (
          <div className="mobile-qr-modal d-flex flex-column justify-content-center align-items-center">
            <span style={{ fontSize: fontSize.mobile.span }}>
              اسکن کد QR موفقیت آمیز بود.
            </span>
            <Link style={{ fontSize: fontSize.mobile.a }} to={"/qr"}>
              {tail}
            </Link>
            <button onClick={() => parent.setState({ tail: null })}>
              انصراف
            </button>
          </div>
        ) : (
          <div className="qr-modal d-flex flex-column justify-content-center align-items-center">
            <span style={{ fontSize: fontSize.mobile.span }}>
              اسکن کد QR موفقیت آمیز بود.
            </span>
            <Link style={{ fontSize: fontSize.mobile.a }} to={"/qr"}>
              {tail}
            </Link>
            <button onClick={() => parent.setState({ tail: null })}>
              انصراف
            </button>
          </div>
        )}
      </>
    );
  }
}
