import React, { Component } from "react";

import "./index.scss";

const maxDesktopSize = 1250;

const fontSize = {
  desktop: {
    strong: window.innerWidth > maxDesktopSize ? 18 : window.innerWidth / 80,
    span: window.innerWidth > maxDesktopSize ? 16 : window.innerWidth / 90,
    button: window.innerWidth > maxDesktopSize ? 18 : window.innerWidth / 80,
  },
};

export default function History(props) {
  const { data } = props;
  return (
    <>
      {window.innerWidth > 1000 ? (
        <div className="activation-history d-flex">
          <div>
            <img src={data.image} alt={data.title} />
            <strong style={{ fontSize: fontSize.desktop.strong }}>
              {data.title}
            </strong>
          </div>
          <span style={{ fontSize: fontSize.desktop.span }}>
            {data.subTitle}
          </span>
          <button style={{ fontSize: fontSize.desktop.button }}>
            {data.status}
          </button>
        </div>
      ) : null}
      {window.innerWidth < 1000 ? (
        <div className="mobile-activation-history d-flex">
          <div className="mobile-activation-history__right d-flex">
            <img src={data.image} alt={data.title} />
            <div className="d-flex flex-column">
              <strong>{data.title}</strong>
              <span>{data.subTitle}</span>
            </div>
          </div>
          <div className="mobile-activation-history__left d-flex">
            <button>{data.status}</button>
          </div>
        </div>
      ) : null}
    </>
  );
}
