import React, { Component } from "react";

import Cellphone from "./Cellphone/index";
import Code from "./Code/index";
import Splash from "../Splash/index";

import { user } from "../../../Redux/actions";
import { connect } from "react-redux";

class Login extends Component {
  constructor(props) {
    super(props);
    this.state = {
      page: 0,
      splash: false,
    };
  }

  async componentDidUpdate() {
    const { cellphone, otp, page } = this.state;
    if (cellphone && !otp) this.props.otp({ cellphone });
    if (page && cellphone && otp)
      this.props.otp_login({
        cellphone,
        otp,
        userToken: "2",
        applicationToken: "22",
      });
  }

  resend = () => {
    const { cellphone } = this.state;
    this.props.otp({ cellphone });
  };

  render() {
    return (
      <>
        {this.state.page === 0 ? (
          !this.state.splash ? (
            <Cellphone parent={this} />
          ) : null
        ) : (
          <Code parent={this} />
        )}
        {this.state.splash ? <Splash /> : null}
      </>
    );
  }
}

export default connect((state) => ({ isLogin: state.user.isLogin }), {
  otp: user.otp,
  otp_login: user.otp_login,
})(Login);
