import React from "react";

import "./index.scss";

const maxDesktopSize = 1250;
const maxMobileSize = 550;

const fontSize = {
  desktop: window.innerWidth > maxDesktopSize ? 16 : window.innerWidth / 65,
  mobile: window.innerWidth > maxMobileSize ? 16 : window.innerWidth / 26,
};
export default function GenderSwitch(props) {
  const { parent, name, options, selectedOption } = props;
  const styles = {
    girl: {
      fontSize: window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
      color: selectedOption === 1 ? "white" : "grey",
      backgroundColor: selectedOption === 1 ? "#128c7e" : "white",
      border: selectedOption === 1 ? "0px" : "1px solid #ccc",
      borderTopLeftRadius: 10,
      borderBottomLeftRadius: 10,
    },
    boy: {
      fontSize: window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
      color: selectedOption === 2 ? "white" : "grey",
      backgroundColor: selectedOption === 2 ? "#128c7e" : "white",
      border: selectedOption === 2 ? "0px" : "1px solid #ccc",
      borderTopRightRadius: 10,
      borderBottomRightRadius: 10,
      // borderLeft: window.innerWidth > 1000 ? "1px solid #ccc" : "0px",
    },
  };
  return (
    <>
      {window.innerWidth > 1000 ? (
        <div className="gender d-flex justify-content-between align-items-center">
          <div style={styles.boy} onClick={() => parent.onChange(name, 2)}>
            {options[0]}
          </div>
          <div style={styles.girl} onClick={() => parent.onChange(name, 1)}>
            {options[1]}
          </div>
        </div>
      ) : null}
      {window.innerWidth < 1000 ? (
        <div className="mobile-gender d-flex justify-content-between align-items-center">
          <div style={styles.boy} onClick={() => parent.onChange(name, 2)}>
            {options[0]}
          </div>
          <div style={styles.girl} onClick={() => parent.onChange(name, 1)}>
            {options[1]}
          </div>
        </div>
      ) : null}
    </>
  );
}
