import React, { useState } from "react";
import TextField from "@material-ui/core/TextField";
import { makeStyles } from "@material-ui/core/styles";

export default function FormPropsTextFields(props) {
  const [value, setValue] = useState(props.defaultValue[props.name]);
  const useStyles = makeStyles((theme) => ({
    root: {
      "& .MuiTextField-root": {
        width: "100%",
        position: "relative",
        marginRight: 10,
        "& input": {
          textAlign: props.align,
          direction: props.align === "right" ? "rtl" : "ltr",
        },
        fontFamily: "numeralLight",
      },
    },
  }));

  const classes = useStyles();
  const { parent, maxLength, onInput, variant, required } = props;
  return (
    <form className={classes.root} noValidate autoComplete="off">
      <div>
        <TextField
          id="outlined-basic"
          name={props.name}
          label={props.label}
          variant={variant || "outlined"}
          onChange={(e) => {
            parent.onChange(e.target.name, e.target.value);
          }}
          // defaultValue={defaultValue[props.name] || ""}
          value={value || ""}
          required={required}
          inputProps={{ maxLength }}
          onInput={(e) => setValue(onInput(e.target.value))}
        />
      </div>
    </form>
  );
}

FormPropsTextFields.defaultProps = {
  align: "right",
  maxLength: "",
  inputMode: "numeric",
  defaultValue: "",
};
