import React from "react";
import { makeStyles } from "@material-ui/core/styles";
import FormControl from "@material-ui/core/FormControl";
import Select from "@material-ui/core/Select";
import KeyboardArrowDownIcon from "@material-ui/icons/KeyboardArrowDown";
import InputLabel from "@material-ui/core/InputLabel";

const useStyles = makeStyles((theme) => ({
  marginLeft: {
    // margin: theme.spacing(1),
    marginLeft: 8,
  },
}));

export default function CustomizedSelects(props) {
  const classes = useStyles();
  const { parent, selectedOptions, required } = props;
  return (
    <>
      {window.innerWidth < 1000 ? (
        <div style={{ position: "relative" }}>
          <FormControl variant="outlined" className={classes.marginLeft}>
            <InputLabel id="demo-simple-select-outlined-label">
              {props.label}
              {required ? <span style={{ color: "red" }}>*</span> : null}
            </InputLabel>
            <Select
              labelId="demo-simple-select-outlined-label"
              id="demo-simple-select-outlined"
              value={selectedOptions}
              onChange={(e) => parent.onChange(props.name, e.target.value)}
            >
              {/* 09366858119 */}
              {props.options.map((item, i) => (
                <option key={i} value={item.id || i}>
                  {item.name || item}
                </option>
              ))}
            </Select>
          </FormControl>
          <KeyboardArrowDownIcon
            style={{
              position: "absolute",
              left: 5,
              top: 20,
              fontSize: 30,
              color: "#a5a5a5",
            }}
          />
        </div>
      ) : null}
      {window.innerWidth > 1000 ? (
        <div style={{ position: "relative" }}>
          <FormControl variant="outlined" className={classes.marginLeft}>
            <InputLabel id="demo-simple-select-outlined-label">
              {props.label}
              {required ? <span style={{ color: "red" }}>*</span> : null}
            </InputLabel>
            <Select
              labelId="demo-simple-select-outlined-label"
              id="demo-simple-select-outlined"
              value={selectedOptions || ""}
              onChange={(e) => parent.onChange(props.name, e.target.value)}
            >
              {/* 09366858119 */}
              {props.options.map((item, i) => (
                <option key={i} value={item.id || i}>
                  {item.name || item}
                </option>
              ))}
            </Select>
          </FormControl>
          <KeyboardArrowDownIcon
            style={{
              position: "absolute",
              left: 5,
              top: 25,
              fontSize: 30,
              color: "#a5a5a5",
            }}
          />
        </div>
      ) : null}
    </>
  );
}
