import React from "react";

import "./index.scss";
export default class ProgressBar extends React.Component {
  state = {
    percent: 0,
  };

  componentDidMount() {
    this.percentInterval = setInterval(() => {
      this.setPercent();
    }, this.props.interval);
  }

  componentWillUnmount() {
    clearInterval(this.percentInterval);
  }

  setPercent = () => {
    this.setState({ percent: this.state.percent + this.props.offset });
  };

  render() {
    return (
      <>
        {window.innerWidth > 1000 ? (
          <div className="progresss d-flex">
            <div style={{ width: this.state.percent + "%" }}>
              {this.state.percent ? (
                <span className="d-flex align-items-center justify-content-center">
                  {this.state.percent}%
                </span>
              ) : null}
            </div>
          </div>
        ) : null}
        {window.innerWidth < 1000 ? (
          <div className="mobile-progress d-flex">
            <div style={{ width: this.state.percent + "%" }}>
              {this.state.percent ? (
                <span className="d-flex align-items-center justify-content-center">
                  {this.state.percent}%
                </span>
              ) : null}
            </div>
          </div>
        ) : null}
      </>
    );
  }
}
