import React from "react";
import Breadcrumbs from "@material-ui/core/Breadcrumbs";
import { Link } from "react-router-dom";

import "./index.scss";

const maxDesktopSize = 1250;

const fontSize = {
  desktop: window.innerWidth > maxDesktopSize ? 12 : window.innerWidth / 90,
  mobile: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 25,
};

export default function ActiveLastBreadcrumb(props) {
  const { name } = props;
  const isblog = window.location.pathname.includes("blog");
  return (
    <Breadcrumbs aria-label="breadcrumb">
      <Link
        style={{
          fontSize:
            window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
        }}
        to={"/"}
      >
        صفحه اصلی
      </Link>
      {isblog ? (
        <Link
          style={{
            fontSize:
              window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
          }}
          to={"/blogs"}
        >
          وبلاگ
        </Link>
      ) : null}
      <Link
        style={{
          fontSize:
            window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
          color: "#00CC69",
        }}
        to={`/${isblog ? "blogs" : "page"}/${window.location.pathname.slice(
          window.location.pathname.lastIndexOf("/") + 1,
          window.location.pathname.length
        )}`}
      >
        {name}
      </Link>
    </Breadcrumbs>
  );
}
