import React from "react";
import Breadcrumbs from "@material-ui/core/Breadcrumbs";
import { Link } from "react-router-dom";

import "./index.scss";

const maxDesktopSize = 1250;

const fontSize = {
  desktop: window.innerWidth > maxDesktopSize ? 12 : window.innerWidth / 90,
  mobile: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 25,
};

export default function ActiveLastBreadcrumb() {
  return (
    <Breadcrumbs aria-label="breadcrumb" style={{ marginBottom: 10 }}>
      <Link
        to={"/"}
        style={{
          fontSize:
            window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
        }}
        // onClick={handleClick}
      >
        صفحه اصلی
      </Link>
      <Link
        to={"/blogs"}
        style={{
          fontSize:
            window.innerWidth > 1000 ? fontSize.desktop : fontSize.mobile,
          color: "#00CC69",
        }}
        // onClick={handleClick}
      >
        وبلاگ
      </Link>
    </Breadcrumbs>
  );
}
