import React, { Component } from "react";
import { Link } from "react-router-dom";
import moment from "jalali-moment";
import Avatar from "@material-ui/core/Avatar";

import "./index.scss";
export default class Chat extends Component {
  render() {
    const { data, selectedUser } = this.props;
    return (
      <>
        {window.innerWidth < 1000 ? (
          <Link to={`/chatroom/${data.id}`} className="chat d-flex">
            <Avatar
              src={data.imageUrl}
              alt={data.name}
              className={"avatar fontLight"}
            />
            <div className="chat__data d-flex flex-column">
              <h1 className="chat__data--name">{data.name}</h1>
              <p className="chat__data--lastMessage">
                {data.lastMessage.slice(0, 40) + "..."}
              </p>
              <span>{data.badge}</span>
              <div>{moment(data.date || new Date()).format("jD/jM hh:mm")}</div>
            </div>
          </Link>
        ) : null}
        {window.innerWidth > 1000 ? (
          <div
            className="chat d-flex"
            onClick={() =>
              this.props.parent.setState({ selectedUser: data.id })
            }
            style={{
              backgroundColor: selectedUser === data.id ? "#eee" : "white",
            }}
          >
            <Avatar
              src={data.imageUrl}
              alt={data.name}
              className={"avatar fontLight"}
            />
            <div className="chat__data d-flex flex-column">
              <h1 className="chat__data--name">{data.name}</h1>
              <p className="chat__data--lastMessage">
                {data.lastMessage.slice(0, 40) + "..."}
              </p>
              <span>{data.badge}</span>
              <div>{moment(data.date || new Date()).format("jD/jM hh:mm")}</div>
            </div>
          </div>
        ) : null}
      </>
    );
  }
}
