import React, { Component } from "react";
import AudioReactRecorder from "audio-react-recorder";
import MicIcon from "@material-ui/icons/Mic";
import CheckIcon from "@material-ui/icons/Check";
import CloseIcon from "@material-ui/icons/Close";
import AttachmentIcon from "@material-ui/icons/Attachment";
import TextField from "@material-ui/core/TextField";
import SendIcon from "@material-ui/icons/Send";
import EmojiEmotions from "@material-ui/icons/EmojiEmotions";
import KeyboardIcon from "@material-ui/icons/Keyboard";
import PhotoCamera from "@material-ui/icons/PhotoCamera";

import "./index.scss";
export default class ChatInputs extends Component {
  state = {
    emoji: false,
  };
  render() {
    const {
      onStop,
      stop,
      start,
      recordState,
      cancel,
      typeText,
      message,

      addFile,
      file,
      addcounter,
    } = this.props;
    return (
      <div className="chat-inputs d-flex  flex-row-reverse">
        <AudioReactRecorder state={recordState} onStop={onStop} />
        {/* <button onClick={start}>Start</button>
        <button onClick={stop}>Stop</button>
        {
            recordState  ? 
            <ReactAudioPlayer
              src={recordState.url}
              autoPlay
              controls
            /> : null
          } */}

        <div className="chat-inputs__voice d-flex flex-row-reverse">
          <div className="chat-inputs__voice d-flex">
            {(recordState === null && message === "" && file === null) ||
            (recordState &&
              recordState.url &&
              message === "" &&
              file === null) ? (
              <div className="chat-inputs__voice--icon d-flex" onClick={start}>
                <MicIcon
                  style={{
                    color: "white",
                    backgroundColor: "#128c7e",
                    width: 50,
                    height: 50,
                    borderRadius: 30,
                    padding: 10,
                  }}
                />
              </div>
            ) : null}
            {message !== "" || file !== null ? (
              <div
                className="chat-inputs__voice--icon d-flex"
                onClick={() => addcounter()}
              >
                <SendIcon
                  style={{
                    padding: "12px 10px 12px 13px",
                    color: "white",
                    backgroundColor: "#128c7e",
                    width: 50,
                    height: 50,
                    borderRadius: 30,
                    transform: "rotate(180deg)",
                  }}
                />
              </div>
            ) : null}
            {recordState === "start" ? (
              <>
                <div
                  className="chat-inputs__voice--icon d-flex mr-2"
                  onClick={cancel}
                >
                  <CloseIcon
                    style={{
                      color: "red",
                      backgroundColor: "white",
                      width: 30,
                      height: 30,
                    }}
                  />
                </div>
                <div className="chat-inputs__voice--icon d-flex" onClick={stop}>
                  <CheckIcon
                    style={{
                      color: "green",
                      backgroundColor: "white",
                      width: 30,
                      height: 30,
                    }}
                  />
                </div>
              </>
            ) : null}
          </div>
        </div>
        {recordState !== "start" ? (
          <div className="chat-inputs__box d-flex flex-row-reverse">
            {message === "" ? (
              <PhotoCamera
                style={{
                  color: "#aaa",
                  marginRight: 0,
                  width: 25,
                  height: 25,
                  margin: "0 3px",
                }}
              />
            ) : null}
            <div className="chat-inputs__box--file">
              <input type="file" onChange={(e) => addFile(e)} />

              <AttachmentIcon
                style={{
                  color: "#aaa",
                  marginRight: 10,
                  width: 25,
                  height: 25,
                  zIndex: 10,
                  position: "absolute",
                  top: 0,
                  left: 0,
                  transform: "rotate(45deg)",
                }}
              />
            </div>

            <TextField
              id="standard-textarea"
              label=""
              value={message}
              placeholder="یک پیام بنویسید..."
              rowsMax={4}
              onChange={(e) => typeText("text", e.target.value)}
              multiline
              style={{
                marginRight: 5,
              }}
            />
            {this.props.parent.state.emoji ? (
              <KeyboardIcon
                style={{
                  color: "#aaa",
                  marginRight: -5,
                  width: 25,
                  height: 25,
                  zIndex: 10,
                  position: "relative",
                  bottom: 5,
                  alignSelf: "flex-end",
                }}
                onClick={() => this.props.parent.setState({ emoji: false })}
              />
            ) : (
              <EmojiEmotions
                style={{
                  color: "#aaa",
                  marginRight: -5,
                  width: 25,
                  height: 25,
                  zIndex: 10,
                  position: "relative",
                  bottom: 5,
                  alignSelf: "flex-end",
                }}
                onClick={() => this.props.parent.setState({ emoji: true })}
              />
            )}
          </div>
        ) : null}
      </div>
    );
  }
}
