import React from "react";
import Carousel from "react-elastic-carousel";
import "./index.scss";
export default function Keyboard({ options, action }) {
  return (
    <div className="chat-suggest portrait-slider d-flex flex-column">
      <Carousel
        itemsToShow={1}
        isRTL={true}
        enableTilt={true}
        showArrows={false}
      >
        {options.map((row, i) => (
          <Row row={row} key={i} action={action} />
        ))}
      </Carousel>
    </div>
  );
}

const Row = ({ row, action }) => {
  return (
    <div className="chat-suggest__row d-flex">
      {row.map((item, i) => (
        <KeyboardItem item={item} key={i} action={action} />
      ))}
    </div>
  );
};

const KeyboardItem = ({ item, action }) => {
  return (
    <div
      className="chat-suggest__row--item d-flex"
      onclick={() => action(item)}
    >
      {item.text}
    </div>
  );
};
