import React, { Component } from "react";
import DoneIcon from "@material-ui/icons/Done";
import DoneAllIcon from "@material-ui/icons/DoneAll";
import EditIcon from "@material-ui/icons/Edit";
import ExpandMoreIcon from "@material-ui/icons/ExpandMore";
import "./index.scss";
import Menu from "@material-ui/core/Menu";
import MenuItem from "@material-ui/core/MenuItem";
import ReplyIcon from "@material-ui/icons/Reply";
import ForwardIcon from "@material-ui/icons/Forward";
import DeleteIcon from "@material-ui/icons/Delete";
import ScheduleIcon from "@material-ui/icons/Schedule";
const menu = [
  { text: "پسند", icon: FavoriteIcon, onClick: () => {} },
  { text: "تبادل نظر", icon: TextsmsIcon, onClick: () => {} },
  { text: "پاسخ", icon: ReplyIcon, onClick: () => {} },
  { text: "باز ارسال", icon: ForwardIcon, onClick: () => {} },
];
const selfMenu = [
  { text: "باز ارسال", icon: ForwardIcon, onClick: () => {} },
  { text: "ویرایش", icon: EditIcon, onClick: () => {} },
  { text: "حذف", icon: DeleteIcon, onClick: () => {} },
];
export default class Comment extends Component {
  state = { messageMenu: null };
  handleClose = () => {
    this.setState({
      messageMenu: null,
    });
  };
  handleClick = (event) => {
    this.setState({
      messageMenu: event.currentTarget,
    });
  };
  render() {
    const { message, user, document, children, addcounter } = this.props;
    const { messageMenu } = this.state;
    const hasavatar = prevUserId != message.userId;

    return (
      <div
        className="comment-message d-flex flex-column d-flex"
        style={{
          filter: document !== null ? "blur(4px)" : "blur(0px)",
        }}
      >
        <div className={`comment-message__box`}>
          <div className="comment-message__box--detail d-flex">
            <div onClick={() => addcounter("nothing")}>
              <ExpandMoreIcon fontSize="small" onClick={this.handleClick} />
            </div>
            <Menu
              anchorEl={messageMenu}
              keepMounted
              open={Boolean(messageMenu)}
              onClose={() => this.handleClose()}
              className="rtl fontLight"
            >
              {(isSelf ? selfMenu : menu).map((e) => (
                <MenuItem
                  className="fontLight"
                  onClick={() => {
                    this.handleClose();
                    e.onClick();
                    addcounter("nothing");
                  }}
                >
                  <e.icon fontSize="small" />
                  {e.text}
                </MenuItem>
              ))}
            </Menu>
          </div>

          <p>{message.text}</p>
        </div>
      </div>
    );
  }
}
