import React, { Component } from "react";
import Normal from "./Normal";
import Inline from "./Inline";
import Sort from "./Sort";
import Slider from "./Slider";
import Select from "./Select";
import MultiSelect from "./MultiSelect";
import Tap from "./Tap";

import "./index.scss";
const types = {
  sort: Sort,
  inline: Inline,
  slider: Slider,
  select: Select,
  multiselect: MultiSelect,
  tap: Tap,
};
export default class Message extends Component {
  render() {
    const {
      message,
      user,
      isSelf,
      file,
      document,
      prevUserId,
      isActive,
      addcounter,
    } = this.props;
    const Action = types[message.action];
    return (
      <div className="Message">
        <Normal
          addcounter={addcounter}
          message={message}
          prevUserId={prevUserId}
          user={user}
          isSelf={isSelf}
          file={file}
          document={document}
        >
          {Action ? (
            <Action
              message={message}
              isSelf={isSelf}
              isActive={isActive}
              action={addcounter}
            />
          ) : null}
          {/* {isActive && (
            <button className="message-2d__submit" onClick={() => action({ value })}>
              ثبت
              <ArrowRightAltIcon />
            </button>
          )} */}
        </Normal>
      </div>
    );
  }
}
