import React, { Component } from 'react';

import './index.scss';

const maxDesktopSize = 1250;

const fontSize = {
  desktop: {
    li: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 90,
  },
  mobile: {
    li: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 25,
  },
};

export default class FileTabs extends Component {
  constructor(props) {
    super(props);
    this.state = {
      type: 'media',
      tabs : [
        {id : 0, value: 'media', name: 'رسانه'},
        {id : 1, value: 'video', name: 'ویدیو'},
        {id : 2, value: 'voice', name: 'صوت'},
        {id : 3, value: 'link', name: 'لینک'},
        {id : 4, value: 'file', name: 'فایل'},
      ],
    };
    
  }

  setType = (val) => {
    this.setState({
      type: val,
    });
  };
  render() {
    return (
      <>
        {
          window.innerWidth < 1000 ?
          <div className="file-tabs d-flex flex-column">
             <ul className="file-tabs__types d-flex flex-row-reverse">
              
              {
                this.state.tabs.map((item,i) => (
                  <li
                    style={{
                      borderBottom: this.state.type === item.value ? '3px solid #00CC69' : 'none',
                      fontSize: fontSize.mobile.li,
                      color: this.state.type === item.value ? '#00CC69' : '#000'
                    }}
                    onClick={() => this.setType(item.value)}
                    key={i}
                  >
                    {item.name}
                  </li>
                ))
              }
            </ul>
            {this.state.type === 'media' ? (
              <div className="file-tabs__media d-flex flex-wrap">
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
                <div className="file-tabs__media--item"></div>
              </div>
            ) : null}
          </div> : null
        }
        {
          window.innerWidth > 1000 ?
          <div className="desktop-file-tabs d-flex flex-column">
            <ul className="desktop-file-tabs__types d-flex flex-row-reverse">
              
              {
                this.state.tabs.map((item,i) => (
                  <li
                    style={{
                      borderBottom: this.state.type === item.value ? '3px solid #00CC69' : 'none',
                      fontSize: fontSize.desktop.li,
                      color: this.state.type === item.value ? '#00CC69' : '#000'
                    }}
                    onClick={() => this.setType(item.value)}
                    key={i}
                  >
                    {item.name}
                  </li>
                ))
              }
            </ul>
            {this.state.type === 'media' ? (
              <div className="desktop-file-tabs__media d-flex flex-wrap">
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>
                <div className="desktop-file-tabs__media--item"></div>

              </div>
            ) : null}
          </div> : null
        }
      </>
      
    );
  }
}
