import React from 'react';
import Carousel from 'react-elastic-carousel';
import CloseIcon from '@material-ui/icons/Close';

import './index.scss';

export default function Gallery(props) {
  // const [state,setState] = useState({

  // });
  return (
    <div className="gallery-modal d-flex justify-content align-items-center">
      <div onClick={() => props.onClick(null)}>
        <CloseIcon
          style={{ color: 'red', width: 46, height: 46, position: 'absolute', right: 5, top: 20 }}
        />
      </div>
      <Carousel itemsToShow={1} isRTL={true} enableTilt={false} showArrows={true}>
        {props.data.map((item, i) => (
          <Image item={item} key={i} />
        ))}
      </Carousel>
    </div>
  );
}

const Image = (props) => {
  return <img style={{ maxHeight: '50%', maxWidth: '100vw' }} src={props.item.src} alt="" />;
};
