import React, { Component } from "react";
import Header from "./Header";
import Body from "./Body";
import Info from "./Info";
import Drawer from "./Drawer/index";

import "./index.scss";
export default class ChatRoom extends Component {
  constructor(props) {
    super(props);
    window.nav = this.nav.bind(this);
    this.state = {
      page: "chatroom",
      open: false,
    };
  }
  nav = (url) => {
    this.props.history.push(url);
  };

  handleDrawerOpen = () => {
    this.setState({
      open: true,
    });
  };

  handleDrawerClose = () => {
    this.setState({
      open: false,
    });
  };

  setPage = (val) => {
    this.setState({
      page: val,
    });
  };
  render() {
    return (
      <>
        {window.innerWidth > 1000 ? (
          <>
            <div className="desktop-chat-room d-flex flex-column">
              <Header
                page={this.state.page}
                setPage={this.setPage}
                parent={this}
              />
              <Body id={this.props.id} setPage={this.setPage} />
            </div>
            <Drawer open={this.state.open} parent={this} />
          </>
        ) : null}
        {window.innerWidth < 1000 ? (
          <div className="chat-room d-flex flex-column">
            {this.state.page === "chatroom" ? (
              <>
                <Header
                  page={this.state.page}
                  setPage={this.setPage}
                  parent={this}
                />
                <Body id={this.props.id} setPage={this.setPage} />
              </>
            ) : (
              <>
                <Info parent={this} />
              </>
            )}
          </div>
        ) : null}
      </>
    );
  }
}
