import React from "react";
import { makeStyles } from "@material-ui/core/styles";
import TextField from "@material-ui/core/TextField";

const useStyles = makeStyles((theme) => ({
  root: {
    "& .MuiTextField-root": {
      margin: 5,
      width: "100%",
    },
  },
}));

export default function MultilineTextFields(props) {
  const classes = useStyles();
  const { parent, defaultValue, required } = props;
  return (
    <form className={classes.root} noValidate autoComplete="off">
      <TextField
        id="outlined-multiline-static"
        label={props.label}
        multiline
        rows={4}
        onChange={(e) => parent.onChange(e.target.name, e.target.value)}
        defaultValue={defaultValue || ""}
        name={props.name}
        variant="outlined"
        required={required}
      />
    </form>
  );
}
