import React from "react";
import TextField from "@material-ui/core/TextField";
import { makeStyles } from "@material-ui/core/styles";

const useStyles = makeStyles((theme) => ({
  root: {
    "& .MuiTextField-root": {
      width: "100%",
      // maxWidth: "400px",
      position: "relative",
      marginTop: 20,
    },
  },
}));

export default function FormPropsTextFields({
  parent,
  name,
  label,
  multiline,
  required,
}) {
  const classes = useStyles();

  return (
    <form className={classes.root} noValidate autoComplete="off">
      <div>
        <TextField
          multiline={multiline}
          id="outlined-basic"
          name={name}
          label={label}
          variant="outlined"
          onChange={(e) => parent.onChange(name, e.target.value)}
          required={required}
        />
      </div>
    </form>
  );
}
