import React from "react";
import { makeStyles, withStyles } from "@material-ui/core/styles";
import ExpandMoreRoundedIcon from "@material-ui/icons/ExpandMoreRounded";
import FormControl from "@material-ui/core/FormControl";
import NativeSelect from "@material-ui/core/NativeSelect";
import InputBase from "@material-ui/core/InputBase";

const BootstrapInput = withStyles((theme) => ({
  root: {
    "label + &": {
      marginTop: theme.spacing(3),
    },
  },
  input: {
    width: "100%",
    // width: "calc(100vw - 20px) !important",
    // maxWidth: "400px !important",
    borderRadius: 4,
    position: "relative",
    backgroundColor: theme.palette.background.paper,
    border: "0px solid #cecece",
    fontSize: 14,
    padding: "10px 26px 10px 12px",
    transition: theme.transitions.create(["border-color", "box-shadow"]),
    // Use the system font instead of the default Roboto font.
  },
}))(InputBase);

const useStyles = makeStyles((theme) => ({
  margin: {
    // margin: theme.spacing(1),
    marginTop: 20,
  },
}));

export default function CustomizedSelects(props) {
  const classes = useStyles();

  return (
    <div className="home-search__select mr-2" style={{ width: "100%" }}>
      <FormControl className={classes.margin} style={{ width: "100%" }}>
        <NativeSelect
          id="demo-customized-select-native"
          onChange={(e) =>
            props.parent.setState({ [props.name]: e.target.value })
          }
          input={<BootstrapInput />}
        >
          {props.options.map((item, i) => (
            <option key={i} value={item[0]}>
              {item[1]}
            </option>
          ))}
        </NativeSelect>
        <ExpandMoreRoundedIcon
          style={{
            position: "absolute",
            left: 5,
            top: "calc(50% - 12px)",
            color: "#777",
          }}
        />
      </FormControl>
    </div>
  );
}
