import React, { Component } from "react";

const maxMobileSize = 550;
const maxDesktopSize = 1250;

const fontSize = {
  mobile: {
    h1: window.innerWidth > maxMobileSize ? 18 : window.innerWidth / 26,
    h2: window.innerWidth > maxMobileSize ? 16 : window.innerWidth / 34,
    div: window.innerWidth > maxMobileSize ? 18 : window.innerWidth / 32,
  },
  desktop: {
    h1: window.innerWidth > maxDesktopSize ? 16 : window.innerWidth / 70,
    div: window.innerWidth > maxDesktopSize ? 16 : window.innerWidth / 85,
    old: window.innerWidth > maxDesktopSize ? 9 : window.innerWidth / 120,
  },
};
const grades = [
  "پیش دبستان",
  "اول",
  "دوم",
  "سوم",
  "چهارم",
  "پنجم",
  "ششم",
  "هفتم",
  "هشتم",
  "نهم",
  "دهم",
  "یازدهم",
  "دوازدهم",
];
export default class Item extends Component {
  render() {
    const { data } = this.props;
    return (
      <>
        {window.innerWidth < 1000 ? (
          <a
            rel="noreferrer"
            href={`https://ar.dnvn.ir/lunch?id=${data.id}`}
            target="_blank"
            className="mobile-products-product d-flex flex-column"
          >
            <img
              src={`https://dnvn.ir/api/v1/file/${data["product.book.fileIds"]}`}
              alt={data.title}
            />
            <div className="mobile-products-product__info d-flex flex-column">
              <h1 style={{ fontSize: fontSize.mobile.h1 }}>
                {data["product.book.name"]}{" "}
                {grades[+data["product.book.gradeId"]]}
              </h1>
            </div>
          </a>
        ) : null}
        {window.innerWidth > 1000 ? (
          <article className="products-product d-flex flex-column align-items"></article>
        ) : null}
      </>
    );
  }
}
