import React, { Component } from "react";
import { connect } from "react-redux";
import { userProduct } from "~/Redux/actions";
import Navbar from "../Home/Navbar/index";

import BreadCrumbs from "./BreadCrumb/index";

import "./index.scss";

const maxDesktopSize = 1250;
const maxMobileSize = 550;

const fontSize = {
  mobile: {
    h1: window.innerWidth > maxMobileSize ? 24 : window.innerWidth / 20,
    a: window.innerWidth > maxMobileSize ? 15 : window.innerWidth / 30,
    p: window.innerWidth > maxMobileSize ? 14 : window.innerWidth / 30,
  },
  desktop: {
    h1: window.innerWidth > maxDesktopSize ? 18 : window.innerWidth / 70,
    a: window.innerHeight > maxDesktopSize ? 15 : window.innerWidth / 85,
    p: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 90,
  },
};

class AR extends Component {
  componentDidMount() {
    window.scrollTo(0, 0);
    if (this.props.status)
      this.props.getMyList({ isActive: 1, productType: 3 });
  }

  render() {
    return (
      <div className="ar d-flex flex-column">
        <Navbar page="home" />
        {window.innerWidth > 1000 ? <BreadCrumbs /> : null}
        <div
          className="mybooks__list--empty d-flex flex-column justify-content-center align-items-center"
          style={{ width: "95vw" }}
        >
          <div
            class="mobile-home-static__flex--right d-flex flex-column"
            style={{ padding: "40px 10px" }}
          >
            <img
              src="https://dnvn.ir/api/v1/file/1851"
              alt="واقعیت افزوده"
              width="150"
            />
          </div>

          <p
            style={{
              textAlign: "center",
              fontSize:
                window.innerWidth > 1000
                  ? fontSize.desktop.p
                  : fontSize.mobile.p,
            }}
          >
            برای استفاده از بخش واقعیت افزوده می بایست افزونه آن را نصب نمایید
          </p>
          <a
            href="https://dnvn.ir/ar.apk"
            style={{
              color: "white",
              backgroundColor: "#128c7e",
              fontSize: 18,
              width: "80%",
              textDecoration: "none",
              borderRadius: 5,
              textAlign: "center",
            }}
          >
            دریافت افزونه
          </a>
        </div>
      </div>
    );
  }
}

export default connect(
  (state) => ({
    status: state.user.status,
    arList: state.userProduct.myList || [],
    loading: state.loading,
  }),
  {
    getMyList: userProduct.myList,
  }
)(AR);
