import React, { Component } from "react";
import { Link } from "react-router-dom";
import location from "../../../assets/icons/location.png";
import home from "../../../assets/icons/home.png";
import contact from "../../../assets/icons/contact.png";

import "./index.scss";
export default class Footer extends Component {
  render() {
    const { fastAccess } = this.props;
    return (
      <>
        {window.innerWidth > 1000 ? (
          <footer className="footer d-flex flex-column">
            <div className="footer-container d-flex">
              <div className="footer-container__content d-flex">
                <div className="footer-container__content--box first d-flex flex-column">
                  <h1>دانوین کجاست؟</h1>
                  <p className="mt-2">
                    ما در دانوین با هدف ایجاد زیرساخت تعاملی و آموزشی با تولید
                    محتوایی جذاب بصورت کتاب قصد داریم تغییراتی بنیادین در نظام
                    آموزش و پرورش کشور ایجاد کنیم.
                  </p>
                  <div className="footer__location d-flex align-items-center mt-2">
                    <img src={location} alt="آدرس" className="m-1" />
                    <p>آدرس: تهران، میدان فردوسی، خیابان موسوی، پلاک ۳۰</p>
                  </div>
                  <div
                    className="d-flex align-items-center mt-1"
                    style={{ width: "55%", justifyContent: "space-between" }}
                  >
                    <div
                      className="d-flex align-items-center"
                      style={{ fontName: "IRANSansNumeralLight" }}
                    >
                      <a
                        href="tel:58795"
                        style={{ textDecoration: "none", color: "white" }}
                      >
                        58795
                      </a>

                      <img src={contact} alt="تماس" className="m-1" />
                    </div>
                    {/* <div
                      className="d-flex align-items-center"
                      style={{
                        fontName: "IRANSansNumeralLight",
                      }}
                    >
                      <a
                        href="tel:02188814673"
                        style={{ textDecoration: "none", color: "white" }}
                      >
                        021-88814673
                      </a>
                      <img src={contact} alt="تماس" className="m-1" />
                    </div> */}
                    <div className="d-flex align-items-center">
                      <span>Info@Danovin.ir</span>
                      <img src={home} alt="خانه" className="m-1" />
                    </div>
                  </div>
                </div>
                <div className="footer-container__content--box second d-flex flex-column">
                  <h1>دسترسی سریع</h1>
                  <ul>
                    {fastAccess.map((item, i) => (
                      <li key={i}>
                        <Link to={item.link}>{item.name}</Link>
                      </li>
                    ))}
                  </ul>
                </div>
                <div className="footer-container__content--box second d-flex flex-column">
                  <h1>لینک های کاربردی</h1>
                  <ul>
                    {fastAccess.map((item, i) => (
                      <li key={i}>
                        <Link to={item.link}>{item.name}</Link>
                      </li>
                    ))}
                  </ul>
                </div>
              </div>
            </div>
            <div className="footer__privacy d-flex align-items-center">
              <p>تمامی حقوق این وبسایت متعلق به دانوین می باشد. 1400</p>
            </div>
          </footer>
        ) : null}
        {window.innerWidth < 1000 ? (
          <footer className="mobile-footer d-flex flex-column">
            <div className="mobile-footer-container d-flex">
              <div className="mobile-footer-container__content d-flex flex-column">
                <div className="mobile-footer-container__content--box first d-flex flex-column">
                  <h1>دانوین کجاست؟</h1>
                  <p className="mt-2">
                    لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و
                    با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه
                    و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی
                    تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای
                    کاربردی می باشد، کتابهای زیادی در شصت و سه{" "}
                  </p>
                  <div className="mobile-footer__location d-flex align-items-center mt-2">
                    <img src={location} alt="آدرس" className="m-1" />
                    <p>
                      تهران خیابان انقلاب اسلامی بن بست سروش پلاک 2 طبقه چهار
                    </p>
                  </div>
                  <div
                    className="d-flex align-items-center mt-1"
                    style={{ width: "55%", justifyContent: "space-between" }}
                  >
                    <div className="d-flex align-items-center">
                      <span>02163462405</span>
                      <img src={contact} alt="تماس" className="m-1" />
                    </div>
                    <div className="d-flex align-items-center">
                      <span>Info@Danovin.ir</span>
                      <img src={home} alt="خانه" className="m-1" />
                    </div>
                  </div>
                </div>
                <div className="mobile-footer-container__content--box second d-flex flex-column">
                  <h1>دسترسی سریع</h1>
                  <ul>
                    {fastAccess.map((item) => (
                      <li>
                        <Link to={item.link}>{item.name}</Link>
                      </li>
                    ))}
                  </ul>
                </div>
                <div className="mobile-footer-container__content--box second d-flex flex-column">
                  <h1>دسترسی سریع</h1>
                  <ul>
                    {fastAccess.map((item) => (
                      <li>
                        <Link to={item.link}>{item.name}</Link>
                      </li>
                    ))}
                  </ul>
                </div>
              </div>
            </div>
            <div className="mobile-footer__privacy d-flex align-items-center">
              <p>تمامی حقوق این وبسایت متعلق به دانوین می باشد. 1400</p>
            </div>
          </footer>
        ) : null}
      </>
    );
  }
}

Footer.defaultProps = {
  fastAccess: [
    { name: "صفحه اصلی", link: "/" },
    { name: "فروشگاه", link: "/shop" },
    { name: "سوالات متداول", link: "/faq" },
    { name: "درباره ما", link: "/about" },
    { name: "تماس با ما", link: "/call" },
  ],
};
