import React, { Component } from "react";
import { Link } from "react-router-dom";
import proxy from "~/Redux/proxy";
import "./index.scss";
const maxDesktopSize = 1250;

const fontSize = {
  desktop: {
    h1: window.innerWidth > maxDesktopSize ? 18 : window.innerWidth / 65,
    h2: window.innerWidth > maxDesktopSize ? 12 : window.innerWidth / 90,
    notAvailable:
      window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 80,
    available: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 80,
  },
};

export default class Simple extends Component {
  render() {
    const mobile = window.innerWidth < 1000;
    const { data } = this.props;
    const status = proxy.status();

    return (
      <article
        className="slider-simple d-flex flex-column"
        style={
          {
            // height: height,
          }
        }
      >
        <Link to={`/products/physical/${data.book.id}`}>
          <img
            src={`https://dnvn.ir/api/v1/file/${data.book.fileIds}`}
            alt={data.title}
            style={{ height: mobile && !status ? 160 : null }}
          />
          <h1 style={{ fontSize: mobile ? 14 : fontSize.desktop.h1 }}>
            {data.name}
          </h1>
          {data.subTitle ? (
            <h2 style={{ fontSize: mobile ? 14 : fontSize.desktop.h2 }}>
              {data.subTitle}
            </h2>
          ) : null}
          {data.price ? (
            <div className="slider-simple__price d-flex justify-content-center">
              <div
                style={{ fontSize: mobile ? 14 : fontSize.desktop.available }}
                className="slider-simple__price--price d-flex"
              >
                {data.price} تومان
              </div>
            </div>
          ) : (
            <div
              style={{ fontSize: fontSize.desktop.notAvailable }}
              className="slider-simple__notAvailabe"
            >
              ناموجود
            </div>
          )}
        </Link>
      </article>
    );
  }
}
