import React from "react";
import { Link } from "react-router-dom";

const maxMobileSize = 540;

const fontSize = {
  h1: window.innerWidth > maxMobileSize ? 19 : window.innerWidth / 28,
  span: window.innerWidth > maxMobileSize ? 12 : window.innerWidth / 35,
};

export default function Flex(props) {
  const { data } = props;
  const style = {
    background: `linear-gradient(${data.backgroundColor.angle},${data.backgroundColor.first} , ${data.backgroundColor.second})`,
    flex: data.flex,
    margin: 5,
    borderRadius: 10,
    color: data.color,
    opacity: data.link === "/chatroom" ? 0.5 : 1,
    filter: data.link === "/chatroom" ? "blur(1px) grayscale(100%)" : "",
  };
  return (
    <Link
      to={data.link === "/chatroom" ? "/" : data.link}
      className="mobile-home-static__flex d-flex align-items-center"
      style={style}
      disabled={true}
    >
      <div className="mobile-home-static__flex--right d-flex flex-column">
        <h1 style={{ fontSize: fontSize.h1 }}>{data.title}</h1>
        {data.badge ? (
          <span
            className="d-flex justify-content-center"
            style={{
              fontSize: fontSize.span,
              backgroundColor: "#F1F907",
              color: "#4D4D4F",
            }}
          >
            {data.badge}
          </span>
        ) : null}
        <span style={{ fontSize: fontSize.span }}>{data.subTitle}</span>
      </div>
      <img
        src={`https://dnvn.ir/api/v1/file/${data.fileId}`}
        alt={data.title}
      />
    </Link>
  );
}
