import React from "react";
import { Link } from "react-router-dom";

const maxMobileSize = 550;

const fontSize = {
  h1: window.innerWidth > maxMobileSize ? 19 : window.innerWidth / 28,
  span: window.innerWidth > maxMobileSize ? 12 : window.innerWidth / 32,
};

export default function Simple(props) {
  const { data } = props;
  const parentStyle = {
    // backgroundImage: `url('${data.imageUrl}')`,
    background: data.fileId
      ? `url('${`https://dnvn.ir/api/v1/file/${data.fileId}`}')`
      : "",
    flex: data.flex,
    backgroundRepeat: "no-repeat",
    backgroundSize: "100% 100%",
    margin: 5,
    borderRadius: 10,
    color: data.color,
    textAlign: "center",
  };

  const childStyle = {
    background: `linear-gradient(${data.backgroundColor.angle},${data.backgroundColor.first} , ${data.backgroundColor.second})`,
    borderRadius: 10,
    justifyContent: data.justifyContent,
    alignItems: data.alignItems,
  };
  return (
    <Link
      to={data.link}
      className="mobile-home-static__simple d-flex"
      style={parentStyle}
    >
      <div style={childStyle} className="d-flex">
        <h1 style={{ fontSize: fontSize.h1 }}>
          {data.title}

          {data.subTitle ? (
            <p style={{ fontSize: 12, paddingTop: 5 }}>{data.subTitle}</p>
          ) : null}
        </h1>
      </div>
    </Link>
  );
}
