import React from "react";
import { Link } from "react-router-dom";

const maxMobileSize = 550;

const fontSize = {
  h1: window.innerWidth > maxMobileSize ? 19 : window.innerWidth / 25,
  span: window.innerWidth > maxMobileSize ? 12 : window.innerWidth / 34,
};

export default function Vitrin(props) {
  const { data } = props;
  const style = {
    // backgroundImage: `url('${data.imageUrl}')`,
    background: `linear-gradient(${data.backgroundColor.angle},${data.backgroundColor.first} , ${data.backgroundColor.second})`,
    flex: data.flex,
    backgroundRepeat: "no-repeat",
    backgroundSize: "100%",
    backgroundOpacity: "60%",
    margin: 5,
    borderRadius: 10,
    color: data.color,
  };

  return (
    <Link
      to={data.link}
      className="mobile-home-static__vitrin d-flex flex-column"
      style={style}
    >
      <span to={data.link}>
        <h1 style={{ fontSize: fontSize.h1 }}>{data.title}</h1>
      </span>

      <div
        className="d-flex  justify-content-around"
        style={{ margin: "auto" }}
      >
        {data.books.map((item, i) => (
          <Item data={item} key={i} />
        ))}
      </div>
    </Link>
  );
}

const Item = (props) => {
  const { data } = props;
  return (
    <div
      // to={"/products/physical/" + data.id}
      className="mobile-home-static__vitrin--product d-flex"
    >
      <img
        src={`https://dnvn.ir/api/v1/file/${data.fileId}`}
        alt={"عکس محصول"}
      />
    </div>
  );
};
