import React from "react";

import "./index.scss";

const maxDesktopSize = 1250;

const fontSize = {
  desktop: {
    h1: window.innerWidth > maxDesktopSize ? 22 : window.innerWidth / 55,
    span: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 80,
    p: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 80,
  },
};
export default function Info(props) {
  const { title, subTitle, description } = props;
  return (
    <>
      {window.innerWidth > 1000 ? (
        <section className="product-info d-flex flex-column">
          <h1 style={{ fontSize: fontSize.desktop.h1 }}>{title}</h1>
          <span style={{ fontSize: fontSize.desktop.span }}>{subTitle}</span>
          <p style={{ fontSize: fontSize.desktop.p }}>{description}</p>
        </section>
      ) : null}
    </>
  );
}
