import React from "react";
import CloseIcon from "@material-ui/icons/Close";

import "./index.scss";

const fontSize = {
  h2: 15, //window.innerWidth > maxDesktopSize ? 13 : window.innerWidth / 85,
  button: 15, //window.innerWidth > maxDesktopSize ? 12 : window.innerWidth / 85,
};
export default class AppliedFilters extends React.Component {
  delete = (name, data) => {
    if (name === "subject") {
      this.props.parent.setState((prevState) => ({
        selectedFilters: {
          ...prevState.selectedFilters,
          subject: prevState.selectedFilters.subject.filter(
            (item) => item !== data
          ),
        },
      }));
    } else if (name === "level") {
      this.props.parent.setState((prevState) => ({
        selectedFilters: {
          ...prevState.selectedFilters,
          level: prevState.selectedFilters.level.filter(
            (item) => item !== data
          ),
        },
      }));
    }
  };
  render() {
    const { data } = this.props;
    return (
      <div className="products-filters-applied d-flex flex-column">
        <header className="products-filters-applied__header d-flex align-items-center">
          <span></span>
          <h2 style={{ fontSize: fontSize.h2 }}>فیلترهای اعمال شده</h2>
        </header>
        <div className="products-filters-applied__items d-flex flex-wrap">
          {data.level.map((item, i) => (
            <Item name={"level"} data={item} key={i} parent={this} />
          ))}
          {data.subject.map((item, i) => (
            <Item name={"subject"} data={item} key={i} parent={this} />
          ))}
        </div>
      </div>
    );
  }
}

const Item = (props) => {
  const { data, name, parent } = props;
  return (
    <button
      className="d-flex align-items-center"
      onClick={() => parent.delete(name, data)}
    >
      <span style={{ fontSize: fontSize.button }}>{data}</span>
      <CloseIcon
        style={{
          fontSize: 12,
          marginRight: 10,
          borderRadius: "50%",
          border: "1px solid #b5b5b5",
        }}
      />
    </button>
  );
};
