import React from "react";
import { connect } from "react-redux";
import { book } from "~/Redux/actions";

import Product from "../Product/index";
import Loader from "~/components/Loader/index";

import "./index.scss";

class List extends React.Component {
  componentDidMount() {
    if (this.props.list?.length === 0) this.props.getList();
  }

  render() {
    let { filterResult, loading } = this.props;

    return window.innerWidth > 1000 ? (
      <div className="products-list d-flex flex-wrap">
        {!loading ? (
          filterResult?.length > 0 ? (
            (Array.isArray(filterResult) ? filterResult : []).map((item, i) => (
              <Product product={item} key={i} />
            ))
          ) : (
            <div>محصولی با این مشخصات یافت نشد</div>

            // (Array.isArray(list) ? list : []).map((item, i) => (
            //   <Product product={item} key={i} />
            // ))
          )
        ) : (
          <div
            className="d-flex justify-content-center align-items-center"
            style={{ height: "100vh", width: "100vw" }}
          >
            <Loader />
          </div>
        )}
      </div>
    ) : (
      <>
        <div
          className="mobile-products-list d-flex flex-wrap"
          style={{ marginBottom: 40 }}
        >
          {!loading ? (
            filterResult.length > 0 ? (
              filterResult.map((item, i) => <Product product={item} key={i} />)
            ) : (
              //list.map((item, i) => <Product product={item} key={i} />)
              <div
                align="center"
                style={{ margin: "20px auto", color: "gray" }}
              >
                محصولی با این مشخصات یافت نشد
              </div>
            )
          ) : (
            <div
              className="d-flex justify-content-center align-items-center"
              style={{ height: "100vh", width: "100vw" }}
            >
              <Loader />
            </div>
          )}
        </div>
      </>
    );
  }
}

export default connect(
  (state) => ({
    list: state.book.list,
    searchResult: state.book.searchResult,
    loading: state.book.loading,
    filterResult: state.book.filterResult,
  }),
  { getList: book.list }
)(List);
