import React from "react";
import SortIcon from "@material-ui/icons/Sort";

import "./index.scss";

const maxDesktopSize = 1250;

const fontSize = {
  span: window.innerWidth > maxDesktopSize ? 14 : window.innerWidth / 90,
  li: window.innerWidth > maxDesktopSize ? 13 : window.innerWidth / 95,
};

export default class Sort extends React.Component {
  render() {
    const { parent, selectedSort } = this.props;
    return (
      <div className="products-sort d-flex align-items-center">
        <SortIcon style={{ fontSize: 30, color: "#A5A5A5", marginLeft: 10 }} />
        <span style={{ fontSize: fontSize.span }}>مرتب سازی بر اساس</span>
        <ul className="d-flex align-items-center mr-2">
          {parent.props.sortItems.map((item, i) => (
            <Item
              data={item}
              key={i}
              parent={parent}
              selectedSort={selectedSort}
            />
          ))}
        </ul>
      </div>
    );
  }
}

const Item = (props) => {
  return (
    <li
      style={{
        fontSize: fontSize.li,
        backgroundColor:
          props.selectedSort === props.data ? "#4CE1BE73" : "white",
      }}
      onClick={() =>
        props.parent.setState({
          selectedFilters: {
            ...props.parent.state.selectedFilters,
            sort: props.data,
          },
        })
      }
    >
      {props.data}
    </li>
  );
};
