import React, { useState } from "react";
import ChevronRightRoundedIcon from "@material-ui/icons/ChevronRightRounded";
import ChevronLeftRoundedIcon from "@material-ui/icons/ChevronLeftRounded";
import CloseRoundedIcon from "@material-ui/icons/CloseRounded";

import "./index.scss";
export default function Modal(props) {
  const [clientX, setClientX] = useState(100);
  const { selectedImage, handleNavigation, setOpen } = props;

  const handleTouch = (val) => {
    if (val - clientX > 20) {
      handleNavigation("left", selectedImage);
    } else if (val - clientX < -20) {
      handleNavigation("right", selectedImage);
    }
  };

  return (
    <>
      {window.innerWidth > 1000 ? null : (
        <div
          className="mobile-qr-image-modal d-flex"
          onTouchStart={(e) => setClientX(e.touches[0].clientX)}
          onTouchEnd={(e) => handleTouch(e.changedTouches[0].clientX)}
        >
          <CloseRoundedIcon
            onClick={() => setOpen(false)}
            style={{
              fontSize: 50,
              color: "red",
              position: "fixed",
              right: 10,
              top: 30,
              zIndex: 1000,
            }}
          />

          <div
            className="mobile-qr-image-modal__slide d-flex justify-content-center align-items-center"
            onClick={() => handleNavigation("right", selectedImage)}
          >
            <ChevronRightRoundedIcon style={{ fontSize: 35, color: "white" }} />
          </div>
          <img src={`https://dnvn.ir/api/v1/file/${selectedImage}`} alt="" />
          <div
            className="mobile-qr-image-modal__slide d-flex justify-content-center align-items-center"
            onClick={() => handleNavigation("left", selectedImage)}
          >
            <ChevronLeftRoundedIcon style={{ fontSize: 35, color: "white" }} />
          </div>
        </div>
      )}
      {window.innerWidth > 1000 ? (
        <div
          className="qr-image-modal d-flex"
          onTouchStart={(e) => setClientX(e.touches[0].clientX)}
          onTouchEnd={(e) => handleTouch(e.changedTouches[0].clientX)}
        >
          <CloseRoundedIcon
            onClick={() => setOpen(false)}
            style={{
              fontSize: 50,
              color: "red",
              position: "fixed",
              right: 10,
              top: 30,
              zIndex: 1000,
            }}
          />

          <div
            className="qr-image-modal__slide d-flex justify-content-center align-items-center"
            onClick={() => handleNavigation("right", selectedImage)}
          >
            <ChevronRightRoundedIcon style={{ fontSize: 55, color: "white" }} />
          </div>
          <img src={`https://dnvn.ir/api/v1/file/${selectedImage}`} alt="" />
          <div
            className="qr-image-modal__slide d-flex justify-content-center align-items-center"
            onClick={() => handleNavigation("left", selectedImage)}
          >
            <ChevronLeftRoundedIcon style={{ fontSize: 55, color: "white" }} />
          </div>
        </div>
      ) : null}
    </>
  );
}
