import React from "react";

import "./index.scss";

const maxMobileSize = 550;

const fontSize = {
  mobile: {
    h2: window.innerWidth > maxMobileSize ? 16 : window.innerWidth / 25,
    a: window.innerWidth > maxMobileSize ? 16 : window.innerWidth / 32,
  },
  desktop: {
    h2: window.innerWidth > maxMobileSize ? 16 : window.innerWidth / 75,
    a: window.innerWidth > maxMobileSize ? 16 : window.innerWidth / 95,
  },
};

export default function Links(props) {
  return (
    <>
      {window.innerWidth > 1000 ? (
        <div className="links-box d-flex flex-column" id="links">
          <h2 style={{ fontSize: fontSize.desktop.h2 }}>{props.data.title}</h2>
        </div>
      ) : null}
      {window.innerWidth < 1000 ? (
        <div className="mobile-links-box d-flex flex-column" id="links">
          <h2 style={{ fontSize: fontSize.mobile.h2 }}>
            <span></span>لینکها
          </h2>
          <ul>
            {props.data.links.map((item, i) => (
              <Item data={item} key={i} />
            ))}
          </ul>
        </div>
      ) : null}
    </>
  );
}

const Item = (props) => {
  return (
    <li>
      <a
        style={{
          fontSize:
            window.innerWidth > 1000 ? fontSize.desktop.a : fontSize.mobile.a,
        }}
        href={props.data.link}
      >
        {props.data.title}
      </a>
    </li>
  );
};
