import React, { Component } from "react";
import ReactPlayer from "react-player";
import "./index.scss";
class VideoApp extends Component {
  player = {};
  state = {
    video: {
      src: `https://dnvn.ir/api/v1/file/${
        this.props.fileId.indexOf(",")
          ? this.props.fileId.split(",")[0]
          : this.props.fileId
      }`,
      poster: this.props.fileId.split(",")[1]
        ? `https://dnvn.ir/api/v1/file/${this.props.fileId.split(",")[1]}`
        : null,
    },
  };

  onPlayerReady(player) {
    this.player = player;
  }

  onVideoPlay(duration) {}

  onVideoPause(duration) {}

  onVideoTimeUpdate(duration) {}

  onVideoSeeking(duration) {}

  onVideoSeeked(from, to) {}

  onVideoEnd() {}

  render() {
    return (
      <ReactPlayer
        style={{ backgroundImage: `url(${this.state.video.poster})` }}
        height="100%"
        width={"100%"}
        type="video/mp4"
        autoPlay={true}
        url={this.state.video.src}
        controls
        playing
        light
        config={{
          file: {
            attributes: {
              poster: this.state.video.poster,
              disablePictureInPicture: true,
              controlsList:
                window.location.host.indexOf("app") > -1
                  ? "nodownload nofullscreen noremoteplayback noplaybackrate"
                  : "nodownload  noremoteplayback noplaybackrate",
            },
          },
        }}
        // controlsList="nofullscreen"
      />
      // </div>
    );
  }
}
export default VideoApp;
