import React from "react";
import MaterialAudioPlayer from "./Material-audio-player/index";
import "./index.scss";

export default function VoiceBox(props) {
  const { data } = props;
  return (
    <>
      {window.innerWidth > 1000 ? (
        <div id="voice" className="voice-box d-flex flex-column">
          <h2
            style={{ fontSize: props.fontSize.desktop.content.h2 }}
            className="d-flex align-items-center"
          >
            <span></span>
            {data.name}
          </h2>
          <MaterialAudioPlayer data={data.fileIds} />
        </div>
      ) : null}
      {window.innerWidth < 1000 ? (
        <div className="mobile-voice-box d-flex flex-column" id="voice">
          <h2 className="d-flex align-items-center">
            <span></span>
            {data.name}
          </h2>
          <MaterialAudioPlayer data={data.fileIds} />
        </div>
      ) : null}
    </>
  );
}
