import React, { useState } from "react";
import TextField from "@material-ui/core/TextField";

export default function FormPropsTextFields(props) {
  const [value, setValue] = useState(props.defaultValue[props.name]);

  const { parent, maxLength, onInput, variant, required } = props;
  return (
    <form noValidate autoComplete="off">
      <div>
        <TextField
          id="outlined-basic"
          className="o4input"
          name={props.name}
          label={props.label}
          variant={variant || "outlined"}
          onChange={(e) => {
            parent.onChange(e.target.name, e.target.value);
          }}
          // defaultValue={defaultValue[props.name] || ""}
          value={value || ""}
          required={required}
          inputProps={{ maxLength }}
          onInput={(e) => setValue(onInput(e.target.value))}
        />
      </div>
    </form>
  );
}

FormPropsTextFields.defaultProps = {
  align: "right",
  maxLength: "",
  inputMode: "numeric",
  defaultValue: "",
};
