import React, { useState } from "react";
import { pdfjs, Document, Page } from "react-pdf";
import LinearProgress from "@material-ui/core/LinearProgress";

import "./index.scss";
import Navbar from "../Home/Navbar/index";
// pdfjs.PDFJS.workerSrc = "/js/pdf.worker.js";
pdfjs.GlobalWorkerOptions.workerSrc = "https://dnvn.ir/pdf.worker.min.js";
const file = (fileId) => `${window.baseURL}file/${fileId}`;

export default function Sample({ fileId }) {
  const [numPages, setNumPages] = useState(null);
  const [pageNumber, setPageNumber] = useState(1);
  const [progress, setProgress] = useState(null);

  function onDocumentLoadSuccess({ numPages }) {
    setNumPages(numPages);
    setProgress(null);
  }
  const id = +window.location.pathname.split("/").slice(-1)[0];
  return (
    <div className="sample" style={{ direction: "ltr" }}>
      <Navbar page="sample" />
      <br />
      <br />
      <br />
      {progress < 100 ? (
        <LinearProgress variant="determinate" value={progress} />
      ) : null}
      <Document
        className="sample_documnet"
        onLoadProgress={({ loaded, total }) => {}}
        file={file(id)}
        onLoadSuccess={onDocumentLoadSuccess}
      >
        <Page
          pageNumber={pageNumber}
          noData="نمونه ای برای این محصول درج نشده است"
        />
      </Document>
      <p>
        صفجه {pageNumber} از {numPages}
      </p>
      <div
        style={{
          borederRadius: 5,
          backgroundColor: "green",
          color: "white",
          cursor: "pointer",
        }}
        onClick={() => setPageNumber(Math.max(1, pageNumber - 1))}
      >
        قبل
      </div>

      <div
        onClick={() => setPageNumber(Math.min(numPages, pageNumber + 1))}
        style={{
          borederRadius: 5,
          backgroundColor: "green",
          color: "white",
          cursor: "pointer",
        }}
      >
        بعد
      </div>
    </div>
  );
}
